require(['config'], function() {
	require([
	], function($) {
		mobPageObj.init();
	});
});

/*API URL*/
const API_MOBILE_GRID_LIST 			= '/api/stock/cdd/detail-grid-list';	// 목록
const API_MOBILE_SAVE 				= '/api/stock/cdd/save-stock-cdd';		// 저장
const API_MOBILE_BARCODE			= '/api/stock/mng/info-barcode-stock';	// 바코드
const API_MOBILE_LOCATION			= '/api/whs/mng/location-grid-list';	// 이력
const API_POP_SEARCH_LIST			= '/api/whs/mng/detail-grid-list';
const API_POP_STOCK_MNG_LIST 		= '/api/stock/mng/detail-grid-list';

const PAGE_MODE_LIST				= "LIST";
const PAGE_MODE_VIEW				= "VIEW";

let mobPageObj = {
	viewMode: PAGE_MODE_LIST,
	init: function () {
		this.ui.init();
		this.event.init();
		this.ready();
	},
	ui: {
		init: function () {
			this.view();
			this.info();
		},
		view: function() {
			// 공통코드 표시
			$('select').each(function() {
				if($(this).data('select-code')) {
					fn_make_select(CODE_LIST, $(this).data('select-code'), $(this).attr('id'));
				}
			});

			// 조회일자 지정
			$('#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH_STCK_DT').val(itp_fn_date_add('M', 0));
		},
		info: function() {
			$('input:hidden[id$="_BRAND_ID"]').val(fn_make_user_info.get('brandId'));
			$('input:hidden[id$="_STORE_ID"]').val(fn_make_user_info.get('storeId'));
		}
	},
	event: {
		init: function() {
			this.button();
		},
		button: function() {
			$('button[id^="ITP_BTN_MSTOCKMNG02010_LIST"]').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MSTOCKMNG02010_LIST_SEARCH_WHS_NM'	: mobPopObj.popWhsNm.init(); 		break;
					case 'ITP_BTN_MSTOCKMNG02010_LIST_DELETE_WHS_NM'	: mobPopObj.popWhsNm.delete(); 		break;
					case 'ITP_BTN_MSTOCKMNG02010_LIST_SEARCH'			: mobContentObj.list.search();		break;
					case 'ITP_BTN_MSTOCKMNG02010_LIST_BARCODE'			: mobContentObj.barcode.callApp();	break;
				}
				return false;
			});

			$('button[id^="ITP_BTN_MSTOCKMNG02010_VIEW"]').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MSTOCKMNG02010_VIEW_SEARCH'		: mobContentObj.view.history.search();	break;
					case 'ITP_BTN_MSTOCKMNG02010_VIEW_CANCEL_LIST'	: mobContentObj.view.cancel();			break;
				}
				return false;
			});

			$(document).on('click', '#ITP_LIST_MSTOCKMNG02010_LIST_ITEM_ROWS li', function() {
				var item = mobContentObj.list.rows[$(this).index()];
				mobContentObj.view.init(item);
			});

			$(document).on('click', '#ITP_LIST_MSTOCKMNG02010_POP_STORE_ROWS li button', function() {
				mobPopObj.popWhsNm.choice($(this));
			});
		}
	},
	switchScreen: function(mode) {
		$('#ITP_MOBILE_MSTOCKMNG02010').find('div[id$="_CONTAINER"]').each(function(i) {
			$(this).hide();
		});
		if(mode === PAGE_MODE_LIST) {
			$('#ITP_AJAX_MSTOCKMNG02010_LIST_CONTAINER').show();
			this.moreView(true);
		} else if(mode === PAGE_MODE_VIEW) {
			$('#ITP_AJAX_MSTOCKMNG02010_VIEW_CONTAINER').show();
			this.moreView(false);
		}
		this.viewMode = mode;
	},
	moreView: function(isScroll) {
		var _this = this;
		if(isScroll) {
			$('#ITP_LIST_MSTOCKMNG02010_LIST_ITEM_AREA').on('scroll', function () {
				if($(this).scrollTop() + $(this).innerHeight() + 1 >= $(this)[0].scrollHeight) {
					if(mobContentObj.list.totPage > mobContentObj.list.listPage) {
						if(!mobContentObj.list.isSearch) {
							mobContentObj.list.load();
						}
					}
				}
			});
		} else {
			$('#ITP_LIST_MSTOCKMNG02010_LIST_AREA').off('scroll');
		}
	},
	ready: function() {
		mobContentObj.list.init();
	}
};

let mobContentObj = {
	list: {
		rows: [],
		init: function() {
			mobPageObj.switchScreen(PAGE_MODE_LIST);
		},
		search: function() {
			var formId = '#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH';
			itp_fn_form_clear_validate(null, formId);
			if (itp_fn_form_event.isValid(formId)) {
				mobPopObj.popItemNm.init();
			}
		},
		validClear: function() {
			var formId = '#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH';
			itp_fn_form_clear_validate(null, formId);
		}
	},
	barcode: {
		callApp: function() {
			var formId = '#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH';
			itp_fn_form_clear_validate(null, formId);
			if (itp_fn_form_event.isValid(formId)) {
				this.callbackFn('');
				// location.replace('app:barcode');
				// location.href = 'app:barcode';
			}
		},
		callbackFn: function(barcode) {
			var infoFn = function(result) {
				console.log(result);
			};
			// const param = {
			// 	'sBrandId': $('#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH #ITP_FORM_MLOANMNG02010_LIST_SEARCH_BRAND_ID').val(),
			// 	'sWhsId': $('#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH #ITP_FORM_MSTOCKMNG02010_LIST_SEARCH_WHS_ID').val(),
			// 	'sLocation': $('#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH #ITP_FORM_MSTOCKMNG02010_LIST_SEARCH_LOCATION').val(),
			// 	'sBarcode': barcode
			// };
			// fn_ajax_call(API_MOBILE_BARCODE, param, callbackFn, 'GET');
			const param = $('#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH').serializeObject();
			param['sBarcode'] = barcode;
			fn_ajax_call(API_MOBILE_BARCODE, JSON.stringify(param), infoFn, 'GET');
		}
	}
};

let mobPopObj = {
	popWhsNm: {
		popId: 'ITP_POP_MSTOCKMNG02010_WHS_AREA',
		rows: [],
		init: function () {
			this.rows.length = 0;
			mobContentObj.list.validClear();
			mobPopObj.show(this.popId);
			this.search();
			this.action();
		},
		search: function () {
			var _this = this;
			$('#ITP_LIST_MSTOCKMNG02010_POP_WHS_AREA .panel-group').empty();
			var callbackFn = function(result) {
				console.log(result);
				_this.view(result.gridRows);
			};
			const param = $('#ITP_FORM_MSTOCKMNG02010_POP_WHS').serializeObject();
			console.log(JSON.stringify(param));
			fn_ajax_call(API_POP_SEARCH_LIST, JSON.stringify(param), callbackFn, 'POST');
		},
		view: function(gridRows) {
			this.rows = gridRows;
			$.each(gridRows, function (i, item) {
				$('#ITP_LIST_MSTOCKMNG02010_POP_WHS_AREA .panel-group').append($('#ITP_LIST_MSTOCKMNG02010_POP_WHS_ROWCOPY').html());
				var $li = $('#ITP_LIST_MSTOCKMNG02010_POP_WHS_AREA .panel-group > .list-row:last');
				$li.find('.fnWhsNm').text(item.whsNm);
				$li.find('.fnLocationNm').text(item.locationNm);
				$li.find('.fnWhsId').data('whs-id', item.whsId);
			});
		},
		choice: function(elem) {
			var _this = this;
			var whsId = $(elem).data('whs-id');
			$.each(this.rows, function (i, item) {
				if(whsId === item.whsId) {
					$('#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH #ITP_FORM_MSTOCKMNG02010_LIST_SEARCH_WHS_ID').val(item.whsId);
					$('#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH #ITP_FORM_MSTOCKMNG02010_LIST_SEARCH_WHS_NM').val(item.whsNm);
					_this.close();
					_this.location(item.whsId);
					return false;
				}
			});
		},
		location: function(whsId) {
			var callbackFn = function(result) {
				fn_make_select_location(result.gridRows, 'ITP_FORM_MSTOCKMNG02010_LIST_SEARCH_LOCATION');
			};
			var param = {
				'brandId': fn_make_user_info.get('brandId'),
				'storeId': fn_make_user_info.get('storeId'),
				'whsId': whsId
			};
			fn_ajax_call(API_MOBILE_LOCATION, JSON.stringify(param), callbackFn, 'POST');
		},
		action: function() {
			var _this = this;
			$('button[id^="ITP_BTN_MSTOCKMNG02010_POP_WHS"]').off('click').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MSTOCKMNG02010_POP_WHS_SEARCH'	: _this.search();			break;
					case 'ITP_BTN_MSTOCKMNG02010_POP_WHS_CHOICE'	: _this.choice($(this)); 	break;
					case 'ITP_BTN_MSTOCKMNG02010_POP_WHS_CLOSE'		: _this.close(); 			break;
				}
				return false;
			});
		},
		delete: function() {
			$('#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH #ITP_FORM_MSTOCKMNG02010_LIST_SEARCH_WHS_ID').val('');
			$('#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH #ITP_FORM_MSTOCKMNG02010_LIST_SEARCH_WHS_NM').val('');
			$('#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH select[name="slocation"] option').empty();
		},
		close: function() {
			this.rows.length = 0;
			$('#ITP_POP_MSTOCKMNG02010_LIST_WHS_AREA .panel-group').empty();
			$('#ITP_FORM_MSTOCKMNG02010_POP_WHS #ITP_FORM_MSTOCKMNG02010_POP_WHS_KEYWORD').val('');
			mobPopObj.hide(this.popId);
		}
	},
	popItemNm: {
		popId: 'ITP_POP_MSTOCKMNG02010_ITEM_AREA',
		rows: [],
		init: function () {
			this.rows.length = 0;
			mobPopObj.show(this.popId);
			this.search();
			this.action();
		},
		search: function () {
			var _this = this;
			var callbackFn = function(result) {
				console.log(result);
				_this.rows = result.gridRows;
				$.each(result.gridRows, function (i, item) {
					$('#ITP_LIST_MSTOCKMNG02010_POP_ITEM_AREA .panel-group').append($('#ITP_LIST_MSTOCKMNG02010_POP_ITEM_ROWCOPY').html());
					var $li = $('#ITP_LIST_MSTOCKMNG02010_POP_ITEM_AREA .panel-group > .list-row:last');
					$li.find('.fnItemId').text(item.itemId);
					$li.find('.fnItemNm').text(item.itemNm);
					$li.find('.fnUnit').text(item.unit);
					$li.find('.fnStckQty').text(CommonObj.currency.add(item.stckQty, '개'));
				});
			};
			var param = $('#ITP_FORM_MSTOCKMNG02010_LIST_SEARCH').serializeObject();
			fn_ajax_call(API_POP_STOCK_MNG_LIST, JSON.stringify(param), callbackFn, 'POST');
		},
		action: function() {

		},
		close: function() {
			this.rows.length = 0;
			$('#ITP_POP_MSTOCKMNG02010_LIST_ITEM_AREA .panel-group').empty();
			$('#ITP_FORM_MSTOCKMNG02010_POP_ITEM #ITP_FORM_MSTOCKMNG02010_POP_ITEM_KEYWORD').val('');
			mobPopObj.hide(this.popId);
		}
	},
	show: function(popId) {
		$('button[id$="_CLOSE"]').off('click').on('click', function() {
			if($(this).hasClass('btn-pop-close')) {
				mobPopObj.hide(popId);
			}
		});
		$('#' + popId).show();
	},
	hide: function(popId) {
		$('#' + popId).closest('.mobile-pop-close').hide();
	}
};
